Merge branch 'mz/pull-rebase-rebased'
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
22
23 Example:       git-rebase master~1 topic
24
25         A---B---C topic                   A'\''--B'\''--C'\'' topic
26        /                   -->           /
27   D---E---F---G master          D---E---F---G master
28 '
29
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
36
37 LF='
38 '
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
44 "
45 unset newbase
46 strategy=recursive
47 strategy_opts=
48 do_merge=
49 dotest="$GIT_DIR"/rebase-merge
50 prec=4
51 verbose=
52 diffstat=
53 test "$(git config --bool rebase.stat)" = true && diffstat=t
54 git_am_opt=
55 rebase_root=
56 force_rebase=
57 allow_rerere_autoupdate=
58
59 continue_merge () {
60         test -n "$prev_head" || die "prev_head must be defined"
61         test -d "$dotest" || die "$dotest directory does not exist"
62
63         unmerged=$(git ls-files -u)
64         if test -n "$unmerged"
65         then
66                 echo "You still have unmerged paths in your index"
67                 echo "did you forget to use git add?"
68                 die "$RESOLVEMSG"
69         fi
70
71         cmt=`cat "$dotest/current"`
72         if ! git diff-index --quiet --ignore-submodules HEAD --
73         then
74                 if ! git commit --no-verify -C "$cmt"
75                 then
76                         echo "Commit failed, please do not call \"git commit\""
77                         echo "directly, but instead do one of the following: "
78                         die "$RESOLVEMSG"
79                 fi
80                 if test -z "$GIT_QUIET"
81                 then
82                         printf "Committed: %0${prec}d " $msgnum
83                 fi
84                 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
85         else
86                 if test -z "$GIT_QUIET"
87                 then
88                         printf "Already applied: %0${prec}d " $msgnum
89                 fi
90         fi
91         test -z "$GIT_QUIET" &&
92         GIT_PAGER='' git log --format=%s -1 "$cmt"
93
94         prev_head=`git rev-parse HEAD^0`
95         # save the resulting commit so we can read-tree on it later
96         echo "$prev_head" > "$dotest/prev_head"
97
98         # onto the next patch:
99         msgnum=$(($msgnum + 1))
100         echo "$msgnum" >"$dotest/msgnum"
101 }
102
103 call_merge () {
104         cmt="$(cat "$dotest/cmt.$1")"
105         echo "$cmt" > "$dotest/current"
106         hd=$(git rev-parse --verify HEAD)
107         cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
108         msgnum=$(cat "$dotest/msgnum")
109         end=$(cat "$dotest/end")
110         eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
111         eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
112         export GITHEAD_$cmt GITHEAD_$hd
113         if test -n "$GIT_QUIET"
114         then
115                 GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
116         fi
117         eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
118         rv=$?
119         case "$rv" in
120         0)
121                 unset GITHEAD_$cmt GITHEAD_$hd
122                 return
123                 ;;
124         1)
125                 git rerere $allow_rerere_autoupdate
126                 die "$RESOLVEMSG"
127                 ;;
128         2)
129                 echo "Strategy: $rv $strategy failed, try another" 1>&2
130                 die "$RESOLVEMSG"
131                 ;;
132         *)
133                 die "Unknown exit code ($rv) from command:" \
134                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
135                 ;;
136         esac
137 }
138
139 move_to_original_branch () {
140         test -z "$head_name" &&
141                 head_name="$(cat "$dotest"/head-name)" &&
142                 onto="$(cat "$dotest"/onto)" &&
143                 orig_head="$(cat "$dotest"/orig-head)"
144         case "$head_name" in
145         refs/*)
146                 message="rebase finished: $head_name onto $onto"
147                 git update-ref -m "$message" \
148                         $head_name $(git rev-parse HEAD) $orig_head &&
149                 git symbolic-ref HEAD $head_name ||
150                 die "Could not move back to $head_name"
151                 ;;
152         esac
153 }
154
155 finish_rb_merge () {
156         move_to_original_branch
157         git notes copy --for-rewrite=rebase < "$dotest"/rewritten
158         if test -x "$GIT_DIR"/hooks/post-rewrite &&
159                 test -s "$dotest"/rewritten; then
160                 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
161         fi
162         rm -r "$dotest"
163         say All done.
164 }
165
166 is_interactive () {
167         while test $# != 0
168         do
169                 case "$1" in
170                         -i|--interactive)
171                                 interactive_rebase=explicit
172                                 break
173                         ;;
174                         -p|--preserve-merges)
175                                 interactive_rebase=implied
176                         ;;
177                 esac
178                 shift
179         done
180
181         if [ "$interactive_rebase" = implied ]; then
182                 GIT_EDITOR=:
183                 export GIT_EDITOR
184         fi
185
186         test -n "$interactive_rebase" || test -f "$dotest"/interactive
187 }
188
189 run_pre_rebase_hook () {
190         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
191            test -x "$GIT_DIR/hooks/pre-rebase"
192         then
193                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
194                 die "The pre-rebase hook refused to rebase."
195         fi
196 }
197
198 test -f "$GIT_DIR"/rebase-apply/applying &&
199         die 'It looks like git-am is in progress. Cannot rebase.'
200
201 is_interactive "$@" && exec git-rebase--interactive "$@"
202
203 while test $# != 0
204 do
205         case "$1" in
206         --no-verify)
207                 OK_TO_SKIP_PRE_REBASE=yes
208                 ;;
209         --continue)
210                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
211                         die "No rebase in progress?"
212
213                 git update-index --ignore-submodules --refresh &&
214                 git diff-files --quiet --ignore-submodules || {
215                         echo "You must edit all merge conflicts and then"
216                         echo "mark them as resolved using git add"
217                         exit 1
218                 }
219                 if test -d "$dotest"
220                 then
221                         prev_head=$(cat "$dotest/prev_head")
222                         end=$(cat "$dotest/end")
223                         msgnum=$(cat "$dotest/msgnum")
224                         onto=$(cat "$dotest/onto")
225                         GIT_QUIET=$(cat "$dotest/quiet")
226                         continue_merge
227                         while test "$msgnum" -le "$end"
228                         do
229                                 call_merge "$msgnum"
230                                 continue_merge
231                         done
232                         finish_rb_merge
233                         exit
234                 fi
235                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
236                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
237                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
238                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
239                 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
240                 move_to_original_branch
241                 exit
242                 ;;
243         --skip)
244                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
245                         die "No rebase in progress?"
246
247                 git reset --hard HEAD || exit $?
248                 if test -d "$dotest"
249                 then
250                         git rerere clear
251                         prev_head=$(cat "$dotest/prev_head")
252                         end=$(cat "$dotest/end")
253                         msgnum=$(cat "$dotest/msgnum")
254                         msgnum=$(($msgnum + 1))
255                         onto=$(cat "$dotest/onto")
256                         GIT_QUIET=$(cat "$dotest/quiet")
257                         while test "$msgnum" -le "$end"
258                         do
259                                 call_merge "$msgnum"
260                                 continue_merge
261                         done
262                         finish_rb_merge
263                         exit
264                 fi
265                 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
266                 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
267                 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
268                 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
269                 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
270                 move_to_original_branch
271                 exit
272                 ;;
273         --abort)
274                 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
275                         die "No rebase in progress?"
276
277                 git rerere clear
278                 if test -d "$dotest"
279                 then
280                         GIT_QUIET=$(cat "$dotest/quiet")
281                         move_to_original_branch
282                 else
283                         dotest="$GIT_DIR"/rebase-apply
284                         GIT_QUIET=$(cat "$dotest/quiet")
285                         move_to_original_branch
286                 fi
287                 git reset --hard $(cat "$dotest/orig-head")
288                 rm -r "$dotest"
289                 exit
290                 ;;
291         --onto)
292                 test 2 -le "$#" || usage
293                 newbase="$2"
294                 shift
295                 ;;
296         -M|-m|--m|--me|--mer|--merg|--merge)
297                 do_merge=t
298                 ;;
299         -X*|--strategy-option*)
300                 case "$#,$1" in
301                 1,-X|1,--strategy-option)
302                         usage ;;
303                 *,-X|*,--strategy-option)
304                         newopt="$2"
305                         shift ;;
306                 *,--strategy-option=*)
307                         newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
308                 *,-X*)
309                         newopt="$(expr " $1" : ' -X\(.*\)')" ;;
310                 1,*)
311                         usage ;;
312                 esac
313                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
314                 do_merge=t
315                 ;;
316         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
317                 --strateg=*|--strategy=*|\
318         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
319                 case "$#,$1" in
320                 *,*=*)
321                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
322                 1,*)
323                         usage ;;
324                 *)
325                         strategy="$2"
326                         shift ;;
327                 esac
328                 do_merge=t
329                 ;;
330         -n|--no-stat)
331                 diffstat=
332                 ;;
333         --stat)
334                 diffstat=t
335                 ;;
336         -v|--verbose)
337                 verbose=t
338                 diffstat=t
339                 GIT_QUIET=
340                 ;;
341         -q|--quiet)
342                 GIT_QUIET=t
343                 git_am_opt="$git_am_opt -q"
344                 verbose=
345                 diffstat=
346                 ;;
347         --whitespace=*)
348                 git_am_opt="$git_am_opt $1"
349                 case "$1" in
350                 --whitespace=fix|--whitespace=strip)
351                         force_rebase=t
352                         ;;
353                 esac
354                 ;;
355         --ignore-whitespace)
356                 git_am_opt="$git_am_opt $1"
357                 ;;
358         --committer-date-is-author-date|--ignore-date)
359                 git_am_opt="$git_am_opt $1"
360                 force_rebase=t
361                 ;;
362         -C*)
363                 git_am_opt="$git_am_opt $1"
364                 ;;
365         --root)
366                 rebase_root=t
367                 ;;
368         -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
369                 force_rebase=t
370                 ;;
371         --rerere-autoupdate|--no-rerere-autoupdate)
372                 allow_rerere_autoupdate="$1"
373                 ;;
374         -*)
375                 usage
376                 ;;
377         *)
378                 break
379                 ;;
380         esac
381         shift
382 done
383 test $# -gt 2 && usage
384
385 if test $# -eq 0 && test -z "$rebase_root"
386 then
387         test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
388         test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
389                 die 'A rebase is in progress, try --continue, --skip or --abort.'
390 fi
391
392 # Make sure we do not have $GIT_DIR/rebase-apply
393 if test -z "$do_merge"
394 then
395         if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
396         then
397                 rmdir "$GIT_DIR"/rebase-apply
398         else
399                 echo >&2 '
400 It seems that I cannot create a rebase-apply directory, and
401 I wonder if you are in the middle of patch application or another
402 rebase.  If that is not the case, please
403         rm -fr '"$GIT_DIR"'/rebase-apply
404 and run me again.  I am stopping in case you still have something
405 valuable there.'
406                 exit 1
407         fi
408 else
409         if test -d "$dotest"
410         then
411                 die "previous rebase directory $dotest still exists." \
412                         'Try git rebase (--continue | --abort | --skip)'
413         fi
414 fi
415
416 require_clean_work_tree "rebase" "Please commit or stash them."
417
418 if test -z "$rebase_root"
419 then
420         # The upstream head must be given.  Make sure it is valid.
421         upstream_name="$1"
422         shift
423         upstream=`git rev-parse --verify "${upstream_name}^0"` ||
424         die "invalid upstream $upstream_name"
425         unset root_flag
426         upstream_arg="$upstream_name"
427 else
428         test -z "$newbase" && die "--root must be used with --onto"
429         unset upstream_name
430         unset upstream
431         root_flag="--root"
432         upstream_arg="$root_flag"
433 fi
434
435 # Make sure the branch to rebase onto is valid.
436 onto_name=${newbase-"$upstream_name"}
437 case "$onto_name" in
438 *...*)
439         if      left=${onto_name%...*} right=${onto_name#*...} &&
440                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
441         then
442                 case "$onto" in
443                 ?*"$LF"?*)
444                         die "$onto_name: there are more than one merge bases"
445                         ;;
446                 '')
447                         die "$onto_name: there is no merge base"
448                         ;;
449                 esac
450         else
451                 die "$onto_name: there is no merge base"
452         fi
453         ;;
454 *)
455         onto=$(git rev-parse --verify "${onto_name}^0") || exit
456         ;;
457 esac
458
459 # If a hook exists, give it a chance to interrupt
460 run_pre_rebase_hook "$upstream_arg" "$@"
461
462 # If the branch to rebase is given, that is the branch we will rebase
463 # $branch_name -- branch being rebased, or HEAD (already detached)
464 # $orig_head -- commit object name of tip of the branch before rebasing
465 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
466 switch_to=
467 case "$#" in
468 1)
469         # Is it "rebase other $branchname" or "rebase other $commit"?
470         branch_name="$1"
471         switch_to="$1"
472
473         if git show-ref --verify --quiet -- "refs/heads/$1" &&
474            branch=$(git rev-parse -q --verify "refs/heads/$1")
475         then
476                 head_name="refs/heads/$1"
477         elif branch=$(git rev-parse -q --verify "$1")
478         then
479                 head_name="detached HEAD"
480         else
481                 usage
482         fi
483         ;;
484 *)
485         # Do not need to switch branches, we are already on it.
486         if branch_name=`git symbolic-ref -q HEAD`
487         then
488                 head_name=$branch_name
489                 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
490         else
491                 head_name="detached HEAD"
492                 branch_name=HEAD ;# detached
493         fi
494         branch=$(git rev-parse --verify "${branch_name}^0") || exit
495         ;;
496 esac
497 orig_head=$branch
498
499 # Now we are rebasing commits $upstream..$branch (or with --root,
500 # everything leading up to $branch) on top of $onto
501
502 # Check if we are already based on $onto with linear history,
503 # but this should be done only when upstream and onto are the same.
504 mb=$(git merge-base "$onto" "$branch")
505 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
506         # linear history?
507         ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
508 then
509         if test -z "$force_rebase"
510         then
511                 # Lazily switch to the target branch if needed...
512                 test -z "$switch_to" || git checkout "$switch_to"
513                 say "Current branch $branch_name is up to date."
514                 exit 0
515         else
516                 say "Current branch $branch_name is up to date, rebase forced."
517         fi
518 fi
519
520 # Detach HEAD and reset the tree
521 say "First, rewinding head to replay your work on top of it..."
522 git checkout -q "$onto^0" || die "could not detach HEAD"
523 git update-ref ORIG_HEAD $branch
524
525 if test -n "$diffstat"
526 then
527         if test -n "$verbose"
528         then
529                 echo "Changes from $mb to $onto:"
530         fi
531         # We want color (if set), but no pager
532         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
533 fi
534
535 # If the $onto is a proper descendant of the tip of the branch, then
536 # we just fast-forwarded.
537 if test "$mb" = "$branch"
538 then
539         say "Fast-forwarded $branch_name to $onto_name."
540         move_to_original_branch
541         exit 0
542 fi
543
544 if test -n "$rebase_root"
545 then
546         revisions="$onto..$orig_head"
547 else
548         revisions="$upstream..$orig_head"
549 fi
550
551 if test -z "$do_merge"
552 then
553         git format-patch -k --stdout --full-index --ignore-if-in-upstream \
554                 --src-prefix=a/ --dst-prefix=b/ \
555                 --no-renames $root_flag "$revisions" |
556         git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
557         move_to_original_branch
558         ret=$?
559         test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
560                 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
561                 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
562                 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
563                 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
564         exit $ret
565 fi
566
567 # start doing a rebase with git-merge
568 # this is rename-aware if the recursive (default) strategy is used
569
570 mkdir -p "$dotest"
571 echo "$onto" > "$dotest/onto"
572 echo "$onto_name" > "$dotest/onto_name"
573 prev_head=$orig_head
574 echo "$prev_head" > "$dotest/prev_head"
575 echo "$orig_head" > "$dotest/orig-head"
576 echo "$head_name" > "$dotest/head-name"
577 echo "$GIT_QUIET" > "$dotest/quiet"
578
579 msgnum=0
580 for cmt in `git rev-list --reverse --no-merges "$revisions"`
581 do
582         msgnum=$(($msgnum + 1))
583         echo "$cmt" > "$dotest/cmt.$msgnum"
584 done
585
586 echo 1 >"$dotest/msgnum"
587 echo $msgnum >"$dotest/end"
588
589 end=$msgnum
590 msgnum=1
591
592 while test "$msgnum" -le "$end"
593 do
594         call_merge "$msgnum"
595         continue_merge
596 done
597
598 finish_rb_merge